package de.duehl.algorithm.backtracking.eightqueens;

public class Square {

    public static final Square A1 = new Square(0, 0);
    public static final Square A2 = new Square(0, 1);
    public static final Square A3 = new Square(0, 2);
    public static final Square A4 = new Square(0, 3);
    public static final Square A5 = new Square(0, 4);
    public static final Square A6 = new Square(0, 5);
    public static final Square A7 = new Square(0, 6);
    public static final Square A8 = new Square(0, 7);

    public static final Square B1 = new Square(1, 0);
    public static final Square B2 = new Square(1, 1);
    public static final Square B3 = new Square(1, 2);
    public static final Square B4 = new Square(1, 3);
    public static final Square B5 = new Square(1, 4);
    public static final Square B6 = new Square(1, 5);
    public static final Square B7 = new Square(1, 6);
    public static final Square B8 = new Square(1, 7);

    public static final Square C1 = new Square(2, 0);
    public static final Square C2 = new Square(2, 1);
    public static final Square C3 = new Square(2, 2);
    public static final Square C4 = new Square(2, 3);
    public static final Square C5 = new Square(2, 4);
    public static final Square C6 = new Square(2, 5);
    public static final Square C7 = new Square(2, 6);
    public static final Square C8 = new Square(2, 7);

    public static final Square D1 = new Square(3, 0);
    public static final Square D2 = new Square(3, 1);
    public static final Square D3 = new Square(3, 2);
    public static final Square D4 = new Square(3, 3);
    public static final Square D5 = new Square(3, 4);
    public static final Square D6 = new Square(3, 5);
    public static final Square D7 = new Square(3, 6);
    public static final Square D8 = new Square(3, 7);

    public static final Square E1 = new Square(4, 0);
    public static final Square E2 = new Square(4, 1);
    public static final Square E3 = new Square(4, 2);
    public static final Square E4 = new Square(4, 3);
    public static final Square E5 = new Square(4, 4);
    public static final Square E6 = new Square(4, 5);
    public static final Square E7 = new Square(4, 6);
    public static final Square E8 = new Square(4, 7);

    public static final Square F1 = new Square(5, 0);
    public static final Square F2 = new Square(5, 1);
    public static final Square F3 = new Square(5, 2);
    public static final Square F4 = new Square(5, 3);
    public static final Square F5 = new Square(5, 4);
    public static final Square F6 = new Square(5, 5);
    public static final Square F7 = new Square(5, 6);
    public static final Square F8 = new Square(5, 7);

    public static final Square G1 = new Square(6, 0);
    public static final Square G2 = new Square(6, 1);
    public static final Square G3 = new Square(6, 2);
    public static final Square G4 = new Square(6, 3);
    public static final Square G5 = new Square(6, 4);
    public static final Square G6 = new Square(6, 5);
    public static final Square G7 = new Square(6, 6);
    public static final Square G8 = new Square(6, 7);

    public static final Square H1 = new Square(7, 0);
    public static final Square H2 = new Square(7, 1);
    public static final Square H3 = new Square(7, 2);
    public static final Square H4 = new Square(7, 3);
    public static final Square H5 = new Square(7, 4);
    public static final Square H6 = new Square(7, 5);
    public static final Square H7 = new Square(7, 6);
    public static final Square H8 = new Square(7, 7);

    private final int file; // Linie

    private final int rank; // Reihe

    public Square(int file, int rank) {
        this.file = file;
        this.rank = rank;
    }

    public int getFile() {
        return file;
    }

    public int getRank() {
        return rank;
    }

    @Override
    public String toString() {
        return "Square [file=" + file + ", rank=" + rank + "]";
    }

    public String toStringNice() {
        String files = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        String fileString = files.substring(file, file + 1); // file darf nicht zu groß werden!
        String rankString = Integer.toString(rank + 1);
        return fileString + rankString;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + file;
        result = prime * result + rank;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        Square other = (Square) obj;
        if (file != other.file) {
            return false;
        }
        if (rank != other.rank) {
            return false;
        }
        return true;
    }

}
