package de.duehl.math.graph.ged.ui.creation.gui;

import javax.swing.JToggleButton;

import de.duehl.math.graph.ged.ui.GuiElements;
import de.duehl.math.graph.ged.ui.graphpanel.EditModus;

public class DirectedGraphInsertEdgeModusButtonPanelCreator
        extends GraphInsertEdgeModusButtonPanelCreator {

    public DirectedGraphInsertEdgeModusButtonPanelCreator(GuiElements elements) {
        super(elements);
    }

    @Override
    protected void createInternal() {
        EditModus modus1 = EditModus.ADD_EDGE_TO_VERTEX;
        EditModus modus2 = EditModus.ADD_BOTH_DIRECTED_EDGE;

        JToggleButton button1 = modus1.getToggleButton();
        JToggleButton button2 = modus2.getToggleButton();

        panel.removeAll();

        gbc.gridx = 0;
        panel.add(button1, gbc);

        gbc.gridx = 1;
        panel.add(button2, gbc);
    }

}
